<?php
// translator ready
// addnews ready
// mail ready
/**************************************************************\
|  Rassen von Lord Eliwood,                                    |
|  Marquis von Pherae,                                         |
|  Admin von http://eliwood.dyndns.org/lotgd                   |
\**************************************************************/

function raceDunkelelf_getmoduleinfo(){
	$info = array(
		"name"=>"Race - Dunkelelf",
		"version"=>"1.5",
		"author"=>"Eliwood",
		"category"=>"Races",
		"download"=>"Nicht downloadbar",
		"settings"=>array(
		"Dunkelelf Race Settings,title",
		"villagename"=>"Name for the Dunkelelf village|Ositia",
		"minedeathchance"=>"Chance for Dunkelelf to die in the mine,range,0,100,1|90",
		),
	);
	return $info;
}

function raceDunkelelf_install(){
	module_addhook("chooserace");
	module_addhook("setrace");
	module_addhook("newday");
	module_addhook("villagetext");
	module_addhook("stabletext");
	module_addhook("travel");
	module_addhook("charstats");
	module_addhook("validlocation");
	module_addhook("validforestloc");
	module_addhook("moderate");
	module_addhook("changesetting");
	module_addhook("raceminedeath");
	module_addhook("stablelocs");
	module_addhook("racenames");
	return true;
}

function raceDunkelelf_uninstall(){
	global $session;
	$vname = getsetting("villagename", LOCATION_FIELDS);
	$gname = get_module_setting("villagename");
	$sql = "UPDATE " . db_prefix("accounts") . " SET location='$vname' WHERE location = '$gname'";
	db_query($sql);
	if ($session['user']['location'] == $gname)
		$session['user']['location'] = $vname;
	// Force anyone who was a Dunkelelf to rechoose race
	$sql = "UPDATE  " . db_prefix("accounts") . " SET race='" . RACE_UNKNOWN . "' WHERE race='Dunkelelf'";
	db_query($sql);
	if ($session['user']['race'] == 'Dunkelelf')
		$session['user']['race'] = RACE_UNKNOWN;
	return true;
}

function raceDunkelelf_dohook($hookname,$args){
	//yeah, the $resline thing is a hack.  Sorry, not sure of a better way
	// to handle this.
	// Pass it as an arg?
	global $session,$resline;
	$city = get_module_setting("villagename");
	$race = "Dunkelelf";
	switch($hookname){
	case "racenames":
		$args[$race] = $race;
		break;
	case "raceminedeath":
		if ($session['user']['race'] == $race) {
			$args['chance'] = get_module_setting("minedeathchance");
		}
		break;
	case "changesetting":
		// Ignore anything other than villagename setting changes
		if ($args['setting'] == "villagename" && $args['module']=="raceDunkelelf") {
			if ($session['user']['location'] == $args['old'])
				$session['user']['location'] = $args['new'];
			$sql = "UPDATE " . db_prefix("accounts") .
				" SET location='" . $args['new'] .
				"' WHERE location='" . $args['old'] . "'";
			db_query($sql);
			if (is_module_active("cities")) {
				$sql = "UPDATE " . db_prefix("module_userprefs") .
					" SET value='" . $args['new'] .
					"' WHERE modulename='cities' AND setting='homecity'" .
					"AND value='" . $args['old'] . "'";
				db_query($sql);
			}
		}
		break;
	case "charstats":
		if ($session['user']['race']==$race){
			addcharstat("Vital Info");
			addcharstat("Race", translate_inline($race));
		}
		break;
	case "chooserace":
		output("`0<a href='newday.php?setrace=$race$resline'>Im Dunklen Wald von %s</a>, der Stadt der `)Dunkelelfen`0; aufgewachsen, hast du gelernt, wie man Elfen verabscheut und brutal mordet`n`n", $city, true);
		addnav("`)Dunkelelf`0","newday.php?setrace=$race$resline");
		addnav("","newday.php?setrace=$race$resline");
		break;
	case "setrace":
		if ($session['user']['race']==$race){
			output("`)Als Dunkelelf kennst du die dunkelsten Technicken und bekommst sowohl Angriffs- wie auch Verteidigungspunkte");
			if (is_module_active("cities")) {
				if ($session['user']['dragonkills']==0 &&
						$session['user']['age']==0){
					//new farmthing, set them to wandering around this city.
					set_module_setting("newest-$city",
							$session['user']['acctid'],"cities");
				}
				set_module_pref("homecity",$city,"cities");
				if ($session['user']['age'] == 0)
					$session['user']['location']=$city;
			}
		}
		break;
	case "newday":
		if ($session['user']['race']==$race){
			raceDunkelelf_checkcity();
			apply_buff("racialbenefit",array(
				"name"=>"`@Dunkelelfische Fhigkeiten`0",
				"atkmod"=>"(<attack>?(1+((1+floor(<level>/7))/<attack>)):0)",
				"defmod"=>"(<defense>?(1+((1+floor(<level>/7))/<defense>)):0)",
				"allowinpvp"=>1,
				"allowintrain"=>1,
				"rounds"=>-1,
				"schema"=>"module-raceDunkelelf",
				)
			);
		}
		break;
	case "validforestloc":
	case "validlocation":
		if (is_module_active("cities"))
			$args[$city]="village-$race";
		break;
	case "moderate":
		if (is_module_active("cities")) {
			tlschema("commentary");
			$args["village-$race"]=sprintf_translate("City of %s", $city);
			tlschema();
		}
		break;
	case "travel":
		$capital = getsetting("villagename", LOCATION_FIELDS);
		$hotkey = substr($city, 0, 1);
		tlschema("module-cities");
		if ($session['user']['location']==$capital){
			addnav("Sichere Reisen");
			addnav(array("%s?Go to %s", $hotkey, $city),"runmodule.php?module=cities&op=travel&city=$city");
		}elseif ($session['user']['location']!=$city){
			addnav("Gefhrliche Reisen");
			addnav(array("%s?Go to %s", $hotkey, $city),"runmodule.php?module=cities&op=travel&city=$city&d=1");
		}
		if ($session['user']['superuser'] & SU_EDIT_USERS){
			addnav("Superuser");
			addnav(array("%s?Go to %s", $hotkey, $city),"runmodule.php?module=cities&op=travel&city=$city&su=1");
		}
		tlschema();
		break;	
	case "villagetext":
		raceDunkelelf_checkcity();
		if ($session['user']['location'] == $city){
			$args['text']=array("`)`c`b%s, Stadt der Dunkelelfen`b`c`n`7Du bist in Ositia, einer dunklen Stadt in mitten des Waldes, hier wimmelt es nur so von Dunkelelfen. Die Dunklen Baumwipfel werfen bedrohliche Schatten ber die ohnehin schon Dunkle Stadt`n", $city, $city);
			$args['schemas']['text'] = "module-raceDunkelelf";
			$args['clock']="`n`7Der Schatten, den die Bume werfen, sagen dir, es ist `)%s`7 Uhr.`n";
			$args['schemas']['clock'] = "module-raceDunkelelf";
			if (is_module_active("calendar")) {
				$args['calendar'] = "`n`7Der Wind, der durch die Bume streift, lsst dich vermuten, das heute der `)%s`7 ist, `)%s %s %s`7.`n";
				$args['schemas']['calendar'] = "module-raceDunkelelf";
			}
			$args['title']=array("%s, Stadt der Dunkelelfen", $city);
			$args['schemas']['title'] = "module-raceDunkelelf";
			$args['sayline']="says";
			$args['schemas']['sayline'] = "module-raceDunkelelf";
			$args['talk']="`n`)Nearby some villagers talk:`n";
			$args['schemas']['talk'] = "module-raceDunkelelf";
			$new = get_module_setting("newest-$city", "cities");
			if ($new != 0) {
				$sql =  "SELECT name FROM " . db_prefix("accounts") .
					" WHERE acctid='$new'";
				$result = db_query_cached($sql, "newest-$city");
				$row = db_fetch_assoc($result);
				$args['newestplayer'] = $row['name'];
				$args['newestid']=$new;
			} else {
				$args['newestplayer'] = $new;
				$args['newestid']="";
			}
			if ($new == $session['user']['acctid']) {
				$args['newest']="`n`7Als du die Stadt genauer anblickst, erkennst du die dunklen Seiten des Lebens.";
			} else {
				$args['newest']="`n`7Ein Fremdling mit Namen `)%s`7 wandert durch das Dorf.";
			}
			$args['schemas']['newest'] = "module-raceDunkelelf";
			$args['section']="village-$race";
			$args['stablename']="Bertold's Bestiary";
			$args['schemas']['stablename'] = "module-raceDunkelelf";
			$args['gatenav']="Stadttore";
			$args['schemas']['gatenav'] = "module-raceDunkelelf";
			unblocknav("stables.php");
		}
		break;
	case "stabletext":
		if ($session['user']['location'] != $city) break;
		$args['title'] = "Bertold's Bestiary";
		$args['schemas']['title'] = "module-raceDunkelelf";
		$args['desc'] = "`6Just outside the outskirts of the village, a training area and riding range has been set up.  Many people from all across the land mingle as Bertold, a strapping man with a wind-weathered face, extols the virtues of each of the creatures in his care.  As you approach, Bertold smiles broadly, \"`^Ahh!, how can I help you today, my %s?`6\", he asks in a booming voice.";
		$args['schemas']['desc'] = "module-raceDunkelelf";
		$args['lad']="friend";
		$args['schemas']['lad'] = "module-raceDunkelelf";
		$args['lass']="friend";
		$args['schemas']['lass'] = "module-raceDunkelelf";
		$args['nosuchbeast']="`6\"`^I'm sorry, I don't stock any such animal.`6\", Bertold say apologetically.";
		$args['schemas']['nosuchbeast'] = "module-raceDunkelelf";
		$args['finebeast']=array(
			"`6\"`^Yes, yes, that's one of my finest beasts!`6\", says Bertold.`n`n",
			"`6\"`^Not even Merick has a finer specimen than this!`6\", Bertold boasts.`n`n",
			"`6\"`^Doesn't this one have fine musculature?`6\", he asks.`n`n",
			"`6\"`^You'll not find a better trained creature in all the land!`6\", exclaims Bertold.`n`n",
			"`6\"`^And a bargain this one'd be at twice the price!`6\", booms Bertold.`n`n",
			);
		$args['schemas']['finebeast'] = "module-raceDunkelelf";
		$args['toolittle']="`6Bertold looks over the gold and gems you offer and turns up his nose, \"`^Obviously you misheard my price.  This %s will cost you `)%s `^gold  and `%%s`^ gems and not a penny less.`6\"";
		$args['schemas']['toolittle'] = "module-raceDunkelelf";
		$args['replacemount']="`6Patting %s`6 on the rump, you hand the reins as well as the money for your new creature, and Bertold hands you the reins of a `)%s`6.";
		$args['schemas']['replacemount'] = "module-raceDunkelelf";
		$args['newmount']="`6You hand over the money for your new creature, and Bertold hands you the reins of a new `)%s`6.";
		$args['schemas']['newmount'] = "module-raceDunkelelf";
		$args['nofeed']="`6\"`^I'm terribly sorry %s, but I don't stock feed here.  I'm not a common stable after all!  Perhaps you should look elsewhere to feed your creature.`6\"";
		$args['schemas']['nofeed'] = "module-raceDunkelelf";
		$args['nothungry']="`)%s`6 picks briefly at the food and then ignores it.  Bertold, being honest, shakes his head and hands you back your gold.";
		$args['schemas']['nothungry'] = "module-raceDunkelelf";
		$args['halfhungry']="`)%s`6dives into the provided food and gets through about half of it before stopping.  \"`^Well, it wasn't as hungry as you thought.`6\" says Bertold as he hands you back all but %s gold.";
		$args['schemas']['halfhungry'] = "module-raceDunkelelf";
		$args['hungry']="`6%s`6 seems to inhale the food provided.  %s`6, the greedy creature that it is, then goes snuffling at Bertold's pockets for more food.`nBertold shakes his head in amusement and collects `)%s`6 gold from you.";
		$args['schemas']['hungry'] = "module-raceDunkelelf";
		$args['mountfull']="`n`6\"`^Well, %s, your %s`^ was truly hungry today, but we've got it full up now.  Come back tomorrow if it hungers again, and I'll be happy to sell you more.`6\", says Bertold with a genial smile.";
		$args['schemas']['mountfull'] = "module-raceDunkelelf";
		$args['nofeedgold']="`6\"`^I'm sorry, but that is just not enough money to pay for food here.`6\"  Bertold turns his back on you, and you lead %s away to find other places for feeding.";
		$args['schemas']['nofeedgold'] = "module-raceDunkelelf";
		$args['confirmsale']="`n`n`6Bertold eyes your mount up and down, checking it over carefully.  \"`^Are you quite sure you wish to part with this creature?`6\"";
		$args['schemas']['confirmsale'] = "module-raceDunkelelf";
		$args['mountsold']="`6With but a single tear, you hand over the reins to your %s`6 to Bertold's stableboy.  The tear dries quickly, and the %s in hand helps you quickly overcome your sorrow.";
		$args['schemas']['mountsold'] = "module-raceDunkelelf";
		$args['offer']="`n`n`6Bertold strokes your creature's flank and offers you `)%s`6 gold and `%%s`6 gems for %s`6.";
		$args['schemas']['offer'] = "module-raceDunkelelf";
		break;
	case "stablelocs":
		tlschema("mounts");
		$args[$city]=sprintf_translate("The Village of %s", $city);
		tlschema();
		break;
	}
	return $args;
}

function raceDunkelelf_checkcity(){
	global $session;
	$race="Dunkelelf";
	$city=get_module_setting("villagename");
	
	if ($session['user']['race']==$race && is_module_active("cities")){
		//if they're this race and their home city isn't right, set it up.
		if (get_module_pref("homecity","cities")!=$city){ //home city is wrong
			set_module_pref("homecity",$city,"cities");
		}
	}	
	return true;
}

function raceDunkelelf_run(){

}
?>